// Copyright (c) 2000-2004  Pavel Rychly

#ifndef FINLIB_EXCEP_HH
#define FINLIB_EXCEP_HH

#include <string>
#include <exception>
#include <cerrno>
#include <cstring>

// -------------------- FileAccessError --------------------

class FileAccessError: public std::exception {
    const std::string _what;
public:
    const std::string filename;
    const std::string where;
    const int err;
    FileAccessError (const std::string &filename, const std::string &where)
	:_what ("FileAccessError (" + filename + ") in " + where 
		+ " [" + strerror (errno) + ']'), 
	filename (filename), where (where), err (errno) {}
    virtual const char* what () const throw () {return _what.c_str();}
    virtual ~FileAccessError() throw () {};
};

// -------------------- MemoryAllocationError --------------------

class MemoryAllocationError: public std::exception {
    const std::string _what;
public:
    const std::string where;
    MemoryAllocationError (const std::string &where)
	:_what ("Cannot allocate memory in " + where), where (where) {}
    virtual const char* what () const throw () {return _what.c_str();}
    virtual ~MemoryAllocationError() throw () {};
};

#endif
